from enum import Enum

# 短路设备设置
DeviceConfig = {
    "box_temperature": 0.00,  # 设备温度
    "surface_temperature": 0.00,  # 表面温度
    "door_status": 0,  # 门状态 0关闭 1开启
    "light_status": 0,  # 灯光状态 0关闭 1开启
    "fan_status": 0,  # 外排风状态 0关闭 1开启
    "warning_light_status": 0,  # 报警灯状态 0关闭 1开启
    "lock_status": 0,  # 锁状态 0关闭 1开启
}

DeviceStatus = {
    "zfm_temperature": 0.00,  # 蒸发皿温度
    "xt_temperature": 0.00,  # 箱体温度
    "kzzt_temperature": 10,  # 温度控制状态
    "exception_status": 10,  # 异常状态1 bit0--继电器通讯失败 bit2--加热功能异常 bit3--制冷功能异常
}

ChannelDatas = list # 通道数据

StopIds = []  # 实验结束的数据



# 登录用户信息
CurrentUser = {
    "username": '',  # 用户名
    "user_id": '',  # 用户id
}

SpecimenInsertDict = {
    "specimen_id": "",  # 证物id
    "specimen_name": "",  # 证物名称
    "specimen_code": "",
    "specimen_type": "",
    "specimen_origin": "",
    "specimen_desc": "",
    "storage_location": "",
    "remark": "",
    "rfid": "",
}

ConfigInsertDict = {
    "config_id": "",
    "ozone_disinf": "",
    "uv_disinf": "",
    "ozone_conc": "",
    "disinf_time": "",
    "temperature": "",
    "humidity": "",
    "config_name": "",
    "config_desc": "",
}

# 新增试验数据
InsertDict = {
    "experiment_id": "",  # 试验id
    "user_id": "",  # 用户id(可传空)
    "user_name": "",  # 用户名(可传空)

    "ozone_disinf": "",
    "uv_disinf": "",
    "ozone_conc": "",
    "disinf_time": "",
    "temperature": "",
    "humidity": "",
    "remark":"",
    "specimens":""

}




# 下位机状态
StatusDict = {
    "status": '', # 消毒状态  0未消毒 1预处理  2消毒中
    "led": "",    #led灯状态 0为灯灭 1为灯亮
    "door": "",   # 门状态 bit0表示外门bit1表示内门 0为关门 000001为开门
    "fans": "",   # 风机状态 0为关 1为开
    "compressor": "", # 压缩机状态 0为关 1为开
    "heating": "",    # 加热管状态 0为关 1为开
    "ozonizer": "",   # 臭氧发生器状态 0为关 1为开
    "disinfectant": "", # 紫外线消毒灯状态 0为关 1为开
    "pump": "",       # 水泵状态 0为关 1为开
    "work_time": "",       # 工作时间(预处理阶段后正式消毒时间)
    "temperature_sensor": "", # 温湿度传感器  0为正常 1为异常
    "voc_sensor": "",         # voc传感器   0为正常 1为异常
    "ozone_sensor": "",       # 臭氧       0为正常 1为异常
    "temperature": "",        # 温度
    "humidity": "",           # 湿度值
    "voc": "",                # voc
    "ozone": "",              #臭氧
}


# 新增试验记录数据
InsertRecordDict = {
    "record_id": "",
    "experiment_id": "",
    "user_id": "",
    "user_name": "",
}

# 结束试验
StopDict = {
    "work_status": "",
}


class ServerStatus:
    """下位机工作状态"""

    IDLE = 0  # 试验空闲
    CONTROL_TEMP = 1  # 实验配气
    INDICAT_POWDER_PRODUCT = 2  # 粉尘喷粉
    POWDER_PRODUCT = 3  # 粉尘点火中
    JUDGMENT_RESULT = 4  # 试验判断
    FINISH = 5  # 试验停止复位
    Remote_Ignition = 6  # 遥控点火
    Pressure_Relief = 7  # 泄压
    Test_Charge = 8  # 试验充能


    @classmethod
    def finish_status(cls):
        return [cls.IDLE]

# 查表法对应数值的1/k,b值
data_lists = [-6.458, -6.457, -6.456, -6.455, -6.453, -6.452, -6.45, -6.448, -6.446, -6.444, -6.441, -6.438, -6.435, -6.432, -6.429, -6.425, -6.421, -6.417, -6.413, -6.408, -6.404, -6.399, -6.393, -6.388, -6.382, -6.377, -6.37, -6.364, -6.358, -6.351, -6.344, -6.337, -6.329, -6.322, -6.314, -6.306, -6.297, -6.289, -6.28, -6.271, -6.262, -6.252, -6.243, -6.233, -6.223, -6.213, -6.202, -6.192, -6.181, -6.17, -6.158, -6.147, -6.135, -6.123, -6.111, -6.099, -6.087, -6.074, -6.061, -6.048, -6.035, -6.021, -6.007, -5.994, -5.98, -5.965, -5.951, -5.936, -5.922, -5.907, -5.891, -5.876, -5.861, -5.845, -5.829, -5.813, -5.797, -5.78, -5.763, -5.747, -5.73, -5.713, -5.695, -5.678, -5.66, -5.642, -5.624, -5.606, -5.588, -5.569, -5.55, -5.531, -5.512, -5.493, -5.474, -5.454, -5.435, -5.415, -5.395, -5.374, -5.354, -5.333, -5.313, -5.292, -5.271, -5.25, -5.228, -5.207, -5.185, -5.163, -5.141, -5.119, -5.097, -5.074, -5.052, -5.029, -5.006, -4.983, -4.96, -4.936, -4.913, -4.889, -4.865, -4.841, -4.817, -4.793, -4.768, -4.744, -4.719, -4.694, -4.669, -4.644, -4.618, -4.593, -4.567, -4.542, -4.516, -4.49, -4.463, -4.437, -4.411, -4.384, -4.357, -4.33, -4.303, -4.276, -4.249, -4.221, -4.194, -4.166, -4.138, -4.11, -4.082, -4.054, -4.025, -3.997, -3.968, -3.939, -3.911, -3.882, -3.852, -3.823, -3.794, -3.764, -3.734, -3.705, -3.675, -3.645, -3.614, -3.584, -3.554, -3.523, -3.492, -3.462, -3.431, -3.4, -3.368, -3.337, -3.306, -3.274, -3.243, -3.211, -3.179, -3.147, -3.115, -3.083, -3.05, -3.018, -2.986, -2.953, -2.92, -2.887, -2.854, -2.821, -2.788, -2.755, -2.721, -2.688, -2.654, -2.62, -2.587, -2.553, -2.519, -2.485, -2.45, -2.416, -2.382, -2.347, -2.312, -2.278, -2.243, -2.208, -2.173, -2.138, -2.103, -2.067, -2.032, -1.996, -1.961, -1.925, -1.889, -1.854, -1.818, -1.782, -1.745, -1.709, -1.673, -1.637, -1.6, -1.564, -1.527, -1.49, -1.453, -1.417, -1.38, -1.343, -1.305, -1.268, -1.231, -1.194, -1.156, -1.119, -1.081, -1.043, -1.006, -0.968, -0.93, -0.892, -0.854, -0.816, -0.778, -0.739, -0.701, -0.663, -0.624, -0.586, -0.547, -0.508, -0.47, -0.431, -0.392, -0.353, -0.314, -0.275, -0.236, -0.197, -0.157, -0.118, -0.079, -0.039, 0, 0.039, 0.079, 0.119, 0.158, 0.198, 0.238, 0.277, 0.317, 0.357, 0.397, 0.437, 0.477, 0.517, 0.557, 0.597, 0.637, 0.677, 0.718, 0.758, 0.798, 0.838, 0.879, 0.919, 0.96, 1, 1.041, 1.081, 1.122, 1.163, 1.203, 1.244, 1.285, 1.326, 1.366, 1.407, 1.448, 1.489, 1.53, 1.571, 1.612, 1.653, 1.694, 1.735, 1.776, 1.817, 1.858, 1.899, 1.941, 1.982, 2.023, 2.064, 2.106, 2.147, 2.188, 2.23, 2.271, 2.312, 2.354, 2.395, 2.436, 2.478, 2.519, 2.561, 2.602, 2.644, 2.685, 2.727, 2.768, 2.81, 2.851, 2.893, 2.934, 2.976, 3.017, 3.059, 3.1, 3.142, 3.184, 3.225, 3.267, 3.308, 3.35, 3.391, 3.433, 3.474, 3.516, 3.557, 3.599, 3.64, 3.682, 3.723, 3.765, 3.806, 3.848, 3.889, 3.931, 3.972, 4.013, 4.055, 4.096, 4.138, 4.179, 4.22, 4.262, 4.303, 4.344, 4.385, 4.427, 4.468, 4.509, 4.55, 4.591, 4.633, 4.674, 4.715, 4.756, 4.797, 4.838, 4.879, 4.92, 4.961, 5.002, 5.043, 5.084, 5.124, 5.165, 5.206, 5.247, 5.288, 5.328, 5.369, 5.41, 5.45, 5.491, 5.532, 5.572, 5.613, 5.653, 5.694, 5.735, 5.775, 5.815, 5.856, 5.896, 5.937, 5.977, 6.017, 6.058, 6.098, 6.138, 6.179, 6.219, 6.259, 6.299, 6.339, 6.38, 6.42, 6.46, 6.5, 6.54, 6.58, 6.62, 6.66, 6.701, 6.741, 6.781, 6.821, 6.861, 6.901, 6.941, 6.981, 7.021, 7.06, 7.1, 7.14, 7.18, 7.22, 7.26, 7.3, 7.34, 7.38, 7.42, 7.46, 7.5, 7.54, 7.579, 7.619, 7.659, 7.699, 7.739, 7.779, 7.819, 7.859, 7.899, 7.939, 7.979, 8.019, 8.059, 8.099, 8.138, 8.178, 8.218, 8.258, 8.298, 8.338, 8.378, 8.418, 8.458, 8.499, 8.539, 8.579, 8.619, 8.659, 8.699, 8.739, 8.779, 8.819, 8.86, 8.9, 8.94, 8.98, 9.02, 9.061, 9.101, 9.141, 9.181, 9.222, 9.262, 9.302, 9.343, 9.383, 9.423, 9.464, 9.504, 9.545, 9.585, 9.626, 9.666, 9.707, 9.747, 9.788, 9.828, 9.869, 9.909, 9.95, 9.991, 10.031, 10.072, 10.113, 10.153, 10.194, 10.235, 10.276, 10.316, 10.357, 10.398, 10.439, 10.48, 10.52, 10.561, 10.602, 10.643, 10.684, 10.725, 10.766, 10.807, 10.848, 10.889, 10.93, 10.971, 11.012, 11.053, 11.094, 11.135, 11.176, 11.217, 11.259, 11.3, 11.341, 11.382, 11.423, 11.465, 11.506, 11.547, 11.588, 11.63, 11.671, 11.712, 11.753, 11.795, 11.836, 11.877, 11.919, 11.96, 12.001, 12.043, 12.084, 12.126, 12.167, 12.209, 12.25, 12.291, 12.333, 12.374, 12.416, 12.457, 12.499, 12.54, 12.582, 12.624, 12.665, 12.707, 12.748, 12.79, 12.831, 12.873, 12.915, 12.956, 12.998, 13.04, 13.081, 13.123, 13.165, 13.206, 13.248, 13.29, 13.331, 13.373, 13.415, 13.457, 13.498, 13.54, 13.582, 13.624, 13.665, 13.707, 13.749, 13.791, 13.833, 13.874, 13.916, 13.958, 14, 14.042, 14.084, 14.126, 14.167, 14.209, 14.251, 14.293, 14.335, 14.377, 14.419, 14.461, 14.503, 14.545, 14.587, 14.629, 14.671, 14.713, 14.755, 14.797, 14.839, 14.881, 14.923, 14.965, 15.007, 15.049, 15.091, 15.133, 15.175, 15.217, 15.259, 15.301, 15.343, 15.385, 15.427, 15.469, 15.511, 15.554, 15.596, 15.638, 15.68, 15.722, 15.764, 15.806, 15.849, 15.891, 15.933, 15.975, 16.017, 16.059, 16.102, 16.144, 16.186, 16.228, 16.27, 16.313, 16.355, 16.397, 16.439, 16.482, 16.524, 16.566, 16.608, 16.651, 16.693, 16.735, 16.778, 16.82, 16.862, 16.904, 16.947, 16.989, 17.031, 17.074, 17.116, 17.158, 17.201, 17.243, 17.285, 17.328, 17.37, 17.413, 17.455, 17.497, 17.54, 17.582, 17.624, 17.667, 17.709, 17.752, 17.794, 17.837, 17.879, 17.921, 17.964, 18.006, 18.049, 18.091, 18.134, 18.176, 18.218, 18.261, 18.303, 18.346, 18.388, 18.431, 18.473, 18.516, 18.558, 18.601, 18.643, 18.686, 18.728, 18.771, 18.813, 18.856, 18.898, 18.941, 18.983, 19.026, 19.068, 19.111, 19.154, 19.196, 19.239, 19.281, 19.324, 19.366, 19.409, 19.451, 19.494, 19.537, 19.579, 19.622, 19.664, 19.707, 19.75, 19.792, 19.835, 19.877, 19.92, 19.962, 20.005, 20.048, 20.09, 20.133, 20.175, 20.218, 20.261, 20.303, 20.346, 20.389, 20.431, 20.474, 20.516, 20.559, 20.602, 20.644, 20.687, 20.73, 20.772, 20.815, 20.857, 20.9, 20.943, 20.985, 21.028, 21.071, 21.113, 21.156, 21.199, 21.241, 21.284, 21.326, 21.369, 21.412, 21.454, 21.497, 21.54, 21.582, 21.625, 21.668, 21.71, 21.753, 21.796, 21.838, 21.881, 21.924, 21.966, 22.009, 22.052, 22.094, 22.137, 22.179, 22.222, 22.265, 22.307, 22.35, 22.393, 22.435, 22.478, 22.521, 22.563, 22.606, 22.649, 22.691, 22.734, 22.776, 22.819, 22.862, 22.904, 22.947, 22.99, 23.032, 23.075, 23.117, 23.16, 23.203, 23.245, 23.288, 23.331, 23.373, 23.416,
              23.458, 23.501, 23.544, 23.586, 23.629, 23.671, 23.714, 23.757, 23.799, 23.842, 23.884, 23.927, 23.97, 24.012, 24.055, 24.097, 24.14, 24.182, 24.225, 24.267, 24.31, 24.353, 24.395, 24.438, 24.48, 24.523, 24.565, 24.608, 24.65, 24.693, 24.735, 24.778, 24.82, 24.863, 24.905, 24.948, 24.99, 25.033, 25.075, 25.118, 25.16, 25.203, 25.245, 25.288, 25.33, 25.373, 25.415, 25.458, 25.5, 25.543, 25.585, 25.627, 25.67, 25.712, 25.755, 25.797, 25.84, 25.882, 25.924, 25.967, 26.009, 26.052, 26.094, 26.136, 26.179, 26.221, 26.263, 26.306, 26.348, 26.39, 26.433, 26.475, 26.517, 26.56, 26.602, 26.644, 26.687, 26.729, 26.771, 26.814, 26.856, 26.898, 26.94, 26.983, 27.025, 27.067, 27.109, 27.152, 27.194, 27.236, 27.278, 27.32, 27.363, 27.405, 27.447, 27.489, 27.531, 27.574, 27.616, 27.658, 27.7, 27.742, 27.784, 27.826, 27.869, 27.911, 27.953, 27.995, 28.037, 28.079, 28.121, 28.163, 28.205, 28.247, 28.289, 28.332, 28.374, 28.416, 28.458, 28.5, 28.542, 28.584, 28.626, 28.668, 28.71, 28.752, 28.794, 28.835, 28.877, 28.919, 28.961, 29.003, 29.045, 29.087, 29.129, 29.171, 29.213, 29.255, 29.297, 29.338, 29.38, 29.422, 29.464, 29.506, 29.548, 29.589, 29.631, 29.673, 29.715, 29.757, 29.798, 29.84, 29.882, 29.924, 29.965, 30.007, 30.049, 30.09, 30.132, 30.174, 30.216, 30.257, 30.299, 30.341, 30.382, 30.424, 30.466, 30.507, 30.549, 30.59, 30.632, 30.674, 30.715, 30.757, 30.798, 30.84, 30.881, 30.923, 30.964, 31.006, 31.047, 31.089, 31.13, 31.172, 31.213, 31.255, 31.296, 31.338, 31.379, 31.421, 31.462, 31.504, 31.545, 31.586, 31.628, 31.669, 31.71, 31.752, 31.793, 31.834, 31.876, 31.917, 31.958, 32, 32.041, 32.082, 32.124, 32.165, 32.206, 32.247, 32.289, 32.33, 32.371, 32.412, 32.453, 32.495, 32.536, 32.577, 32.618, 32.659, 32.7, 32.742, 32.783, 32.824, 32.865, 32.906, 32.947, 32.988, 33.029, 33.07, 33.111, 33.152, 33.193, 33.234, 33.275, 33.316, 33.357, 33.398, 33.439, 33.48, 33.521, 33.562, 33.603, 33.644, 33.685, 33.726, 33.767, 33.808, 33.848, 33.889, 33.93, 33.971, 34.012, 34.053, 34.093, 34.134, 34.175, 34.216, 34.257, 34.297, 34.338, 34.379, 34.42, 34.46, 34.501, 34.542, 34.582, 34.623, 34.664, 34.704, 34.745, 34.786, 34.826, 34.867, 34.908, 34.948, 34.989, 35.029, 35.07, 35.11, 35.151, 35.192, 35.232, 35.273, 35.313, 35.354, 35.394, 35.435, 35.475, 35.516, 35.556, 35.596, 35.637, 35.677, 35.718, 35.758, 35.798, 35.839, 35.879, 35.92, 35.96, 36, 36.041, 36.081, 36.121, 36.162, 36.202, 36.242, 36.282, 36.323, 36.363, 36.403, 36.443, 36.484, 36.524, 36.564, 36.604, 36.644, 36.685, 36.725, 36.765, 36.805, 36.845, 36.885, 36.925, 36.965, 37.006, 37.046, 37.086, 37.126, 37.166, 37.206, 37.246, 37.286, 37.326, 37.366, 37.406, 37.446, 37.486, 37.526, 37.566, 37.606, 37.646, 37.686, 37.725, 37.765, 37.805, 37.845, 37.885, 37.925, 37.965, 38.005, 38.044, 38.084, 38.124, 38.164, 38.204, 38.243, 38.283, 38.323, 38.363, 38.402, 38.442, 38.482, 38.522, 38.561, 38.601, 38.641, 38.68, 38.72, 38.76, 38.799, 38.839, 38.878, 38.918, 38.958, 38.997, 39.037, 39.076, 39.116, 39.155, 39.195, 39.235, 39.274, 39.314, 39.353, 39.393, 39.432, 39.471, 39.511, 39.55, 39.59, 39.629, 39.669, 39.708, 39.747, 39.787, 39.826, 39.866, 39.905, 39.944, 39.984, 40.023, 40.062, 40.101, 40.141, 40.18, 40.219, 40.259, 40.298, 40.337, 40.376, 40.415, 40.455, 40.494, 40.533, 40.572, 40.611, 40.651, 40.69, 40.729, 40.768, 40.807, 40.846, 40.885, 40.924, 40.963, 41.002, 41.042, 41.081, 41.12, 41.159, 41.198, 41.237, 41.276, 41.315, 41.354, 41.393, 41.431, 41.47, 41.509, 41.548, 41.587, 41.626, 41.665, 41.704, 41.743, 41.781, 41.82, 41.859, 41.898, 41.937, 41.976, 42.014, 42.053, 42.092, 42.131, 42.169, 42.208, 42.247, 42.286, 42.324, 42.363, 42.402, 42.44, 42.479, 42.518, 42.556, 42.595, 42.633, 42.672, 42.711, 42.749, 42.788, 42.826, 42.865, 42.903, 42.942, 42.98, 43.019, 43.057, 43.096, 43.134, 43.173, 43.211, 43.25, 43.288, 43.327, 43.365, 43.403, 43.442, 43.48, 43.518, 43.557, 43.595, 43.633, 43.672, 43.71, 43.748, 43.787, 43.825, 43.863, 43.901, 43.94, 43.978, 44.016, 44.054, 44.092, 44.13, 44.169, 44.207, 44.245, 44.283, 44.321, 44.359, 44.397, 44.435, 44.473, 44.512, 44.55, 44.588, 44.626, 44.664, 44.702, 44.74, 44.778, 44.816, 44.853, 44.891, 44.929, 44.967, 45.005, 45.043, 45.081, 45.119, 45.157, 45.194, 45.232, 45.27, 45.308, 45.346, 45.383, 45.421, 45.459, 45.497, 45.534, 45.572, 45.61, 45.647, 45.685, 45.723, 45.76, 45.798, 45.836, 45.873, 45.911, 45.948, 45.986, 46.024, 46.061, 46.099, 46.136, 46.174, 46.211, 46.249, 46.286, 46.324, 46.361, 46.398, 46.436, 46.473, 46.511, 46.548, 46.585, 46.623, 46.66, 46.697, 46.735, 46.772, 46.809, 46.847, 46.884, 46.921, 46.958, 46.995, 47.033, 47.07, 47.107, 47.144, 47.181, 47.218, 47.256, 47.293, 47.33, 47.367, 47.404, 47.441, 47.478, 47.515, 47.552, 47.589, 47.626, 47.663, 47.7, 47.737, 47.774, 47.811, 47.848, 47.884, 47.921, 47.958, 47.995, 48.032, 48.069, 48.105, 48.142, 48.179, 48.216, 48.252, 48.289, 48.326, 48.363, 48.399, 48.436, 48.473, 48.509, 48.546, 48.582, 48.619, 48.656, 48.692, 48.729, 48.765, 48.802, 48.838, 48.875, 48.911, 48.948, 48.984, 49.021, 49.057, 49.093, 49.13, 49.166, 49.202, 49.239, 49.275, 49.311, 49.348, 49.384, 49.42, 49.456, 49.493, 49.529, 49.565, 49.601, 49.637, 49.674, 49.71, 49.746, 49.782, 49.818, 49.854, 49.89, 49.926, 49.962, 49.998, 50.034, 50.07, 50.106, 50.142, 50.178, 50.214, 50.25, 50.286, 50.322, 50.358, 50.393, 50.429, 50.465, 50.501, 50.537, 50.572, 50.608, 50.644, 50.68, 50.715, 50.751, 50.787, 50.822, 50.858, 50.894, 50.929, 50.965, 51, 51.036, 51.071, 51.107, 51.142, 51.178, 51.213, 51.249, 51.284, 51.32, 51.355, 51.391, 51.426, 51.461, 51.497, 51.532, 51.567, 51.603, 51.638, 51.673, 51.708, 51.744, 51.779, 51.814, 51.849, 51.885, 51.92, 51.955, 51.99, 52.025, 52.06, 52.095, 52.13, 52.165, 52.2, 52.235, 52.27, 52.305, 52.34, 52.375, 52.41, 52.445, 52.48, 52.515, 52.55, 52.585, 52.62, 52.654, 52.689, 52.724, 52.759, 52.794, 52.828, 52.863, 52.898, 52.932, 52.967, 53.002, 53.037, 53.071, 53.106, 53.14, 53.175, 53.21, 53.244, 53.279, 53.313, 53.348, 53.382, 53.417, 53.451, 53.486, 53.52, 53.555, 53.589, 53.623, 53.658, 53.692, 53.727, 53.761, 53.795, 53.83, 53.864, 53.898, 53.932, 53.967, 54.001, 54.035, 54.069, 54.104, 54.138, 54.172, 54.206, 54.24, 54.274, 54.308, 54.343, 54.377, 54.411, 54.445, 54.479, 54.513, 54.547, 54.581, 54.615, 54.649, 54.683, 54.717, 54.751, 54.785, 54.819, 54.852]
k_list = [0.001, 0.001, 0.001, 0.002, 0.001, 0.002, 0.002, 0.002, 0.002, 0.003, 0.003, 0.003, 0.003, 0.003, 0.004, 0.004, 0.004, 0.004, 0.005, 0.004, 0.005, 0.006, 0.005, 0.006, 0.005, 0.007, 0.006, 0.006, 0.007, 0.007, 0.007, 0.008, 0.007, 0.008, 0.008, 0.009, 0.008, 0.009, 0.009, 0.009, 0.01, 0.009, 0.01, 0.01, 0.01, 0.011, 0.01, 0.011, 0.011, 0.012, 0.011, 0.012, 0.012, 0.012, 0.012, 0.012, 0.013, 0.013, 0.013, 0.013, 0.014, 0.014, 0.013, 0.014, 0.015, 0.014, 0.015, 0.014, 0.015, 0.016, 0.015, 0.015, 0.016, 0.016, 0.016, 0.016, 0.017, 0.017, 0.016, 0.017, 0.017, 0.018, 0.017, 0.018, 0.018, 0.018, 0.018, 0.018, 0.019, 0.019, 0.019, 0.019, 0.019, 0.019, 0.02, 0.019, 0.02, 0.02, 0.021, 0.02, 0.021, 0.02, 0.021, 0.021, 0.021, 0.022, 0.021, 0.022, 0.022, 0.022, 0.022, 0.022, 0.023, 0.022, 0.023, 0.023, 0.023, 0.023, 0.024, 0.023, 0.024, 0.024, 0.024, 0.024, 0.024, 0.025, 0.024, 0.025, 0.025, 0.025, 0.025, 0.026, 0.025, 0.026, 0.025, 0.026, 0.026, 0.027, 0.026, 0.026, 0.027, 0.027, 0.027, 0.027, 0.027, 0.027, 0.028, 0.027, 0.028, 0.028, 0.028, 0.028, 0.028, 0.029, 0.028, 0.029, 0.029, 0.028, 0.029, 0.03, 0.029, 0.029, 0.03, 0.03, 0.029, 0.03, 0.03, 0.031, 0.03, 0.03, 0.031, 0.031, 0.03, 0.031, 0.031, 0.032, 0.031, 0.031, 0.032, 0.031, 0.032, 0.032, 0.032, 0.032, 0.032, 0.033, 0.032, 0.032, 0.033, 0.033, 0.033, 0.033, 0.033, 0.033, 0.033, 0.034, 0.033, 0.034, 0.034, 0.033, 0.034, 0.034, 0.034, 0.035, 0.034, 0.034, 0.035, 0.035, 0.034, 0.035, 0.035, 0.035, 0.035, 0.035, 0.036, 0.035, 0.036, 0.035, 0.036, 0.036, 0.035, 0.036, 0.036, 0.037, 0.036, 0.036, 0.036, 0.037, 0.036, 0.037, 0.037, 0.037, 0.036, 0.037, 0.037, 0.038, 0.037, 0.037, 0.037, 0.038, 0.037, 0.038, 0.038, 0.037, 0.038, 0.038, 0.038, 0.038, 0.038, 0.038, 0.039, 0.038, 0.038, 0.039, 0.038, 0.039, 0.039, 0.038, 0.039, 0.039, 0.039, 0.039, 0.039, 0.039, 0.039, 0.04, 0.039, 0.039, 0.04, 0.039, 0.039, 0.04, 0.04, 0.039, 0.04, 0.04, 0.039, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.041, 0.04, 0.04, 0.04, 0.041, 0.04, 0.041, 0.04, 0.041, 0.04, 0.041, 0.041, 0.04, 0.041, 0.041, 0.041, 0.04, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.042, 0.041, 0.041, 0.041, 0.042, 0.041, 0.041, 0.042, 0.041, 0.041, 0.042, 0.041, 0.041, 0.042, 0.041, 0.042, 0.041, 0.042, 0.041, 0.042, 0.041, 0.042, 0.041, 0.042, 0.041, 0.042, 0.041, 0.042, 0.041, 0.042, 0.042, 0.041, 0.042, 0.041, 0.042, 0.041, 0.042, 0.041, 0.042, 0.041, 0.042, 0.041, 0.042, 0.041, 0.042, 0.041, 0.042, 0.041, 0.042, 0.041, 0.041, 0.042, 0.041, 0.042, 0.041, 0.041, 0.042, 0.041, 0.041, 0.041, 0.042, 0.041, 0.041, 0.041, 0.041, 0.042, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.04, 0.041, 0.041, 0.041, 0.041, 0.04, 0.041, 0.041, 0.04, 0.041, 0.041, 0.04, 0.041, 0.04, 0.041, 0.041, 0.04, 0.04, 0.041, 0.04, 0.041, 0.04, 0.04, 0.041, 0.04, 0.04, 0.041, 0.04, 0.04, 0.04, 0.04, 0.041, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.041, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.039, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.039, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.039, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.041, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.041, 0.04, 0.04, 0.04, 0.04, 0.041, 0.04, 0.04, 0.04, 0.041, 0.04, 0.04, 0.041, 0.04, 0.04, 0.041, 0.04, 0.041, 0.04, 0.041, 0.04, 0.041, 0.04, 0.041, 0.04, 0.041, 0.04, 0.041, 0.041, 0.04, 0.041, 0.041, 0.04, 0.041, 0.041, 0.041, 0.04, 0.041, 0.041, 0.041, 0.041, 0.04, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.042, 0.041, 0.041, 0.041, 0.041, 0.042, 0.041, 0.041, 0.041, 0.042, 0.041, 0.041, 0.041, 0.042, 0.041, 0.041, 0.042, 0.041, 0.041, 0.042, 0.041, 0.042, 0.041, 0.042, 0.041, 0.041, 0.042, 0.041, 0.042, 0.041, 0.042, 0.041, 0.042, 0.042, 0.041, 0.042, 0.041, 0.042, 0.041, 0.042, 0.042, 0.041, 0.042, 0.042, 0.041, 0.042, 0.042, 0.041, 0.042, 0.042, 0.041, 0.042, 0.042, 0.042, 0.041, 0.042, 0.042, 0.042, 0.041, 0.042, 0.042, 0.042, 0.042, 0.041, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.041, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.043, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.043, 0.042, 0.042, 0.042, 0.042, 0.042, 0.043, 0.042, 0.042, 0.042, 0.042, 0.043, 0.042, 0.042, 0.042, 0.043, 0.042, 0.042, 0.042, 0.043, 0.042, 0.042, 0.043, 0.042, 0.042, 0.042, 0.043, 0.042, 0.042, 0.043, 0.042, 0.042, 0.043, 0.042, 0.042, 0.043, 0.042, 0.043, 0.042, 0.042, 0.043, 0.042, 0.042, 0.043, 0.042, 0.043, 0.042, 0.043, 0.042, 0.042, 0.043, 0.042, 0.043, 0.042, 0.043, 0.042, 0.042, 0.043, 0.042, 0.043, 0.042, 0.043, 0.042, 0.043, 0.042, 0.043, 0.042, 0.043, 0.042, 0.043, 0.042, 0.043, 0.042, 0.043, 0.042, 0.043, 0.042, 0.043, 0.043, 0.042, 0.043, 0.042, 0.043, 0.042, 0.043, 0.042, 0.043, 0.043, 0.042, 0.043, 0.042, 0.043, 0.043, 0.042, 0.043, 0.042, 0.043, 0.042, 0.043, 0.043, 0.042, 0.043, 0.042, 0.043, 0.043, 0.042, 0.043, 0.043, 0.042, 0.043, 0.042, 0.043, 0.043, 0.042, 0.043, 0.043, 0.042, 0.043, 0.042, 0.043, 0.043, 0.042, 0.043, 0.043, 0.042, 0.043, 0.043, 0.042, 0.043, 0.042, 0.043, 0.043, 0.042, 0.043, 0.043, 0.042, 0.043, 0.043, 0.042, 0.043, 0.043, 0.042, 0.043, 0.043, 0.042, 0.043, 0.043, 0.042, 0.043, 0.042, 0.043, 0.043, 0.042, 0.043, 0.043, 0.042, 0.043, 0.043, 0.042, 0.043, 0.043, 0.042, 0.043, 0.042, 0.043, 0.043, 0.042,
          0.043, 0.043, 0.042, 0.043, 0.042, 0.043, 0.043, 0.042, 0.043, 0.043, 0.042, 0.043, 0.042, 0.043, 0.043, 0.042, 0.043, 0.042, 0.043, 0.043, 0.042, 0.043, 0.042, 0.043, 0.043, 0.042, 0.043, 0.042, 0.043, 0.042, 0.043, 0.042, 0.043, 0.043, 0.042, 0.043, 0.042, 0.043, 0.042, 0.043, 0.042, 0.043, 0.042, 0.043, 0.042, 0.043, 0.042, 0.043, 0.042, 0.043, 0.042, 0.043, 0.042, 0.043, 0.042, 0.043, 0.042, 0.043, 0.042, 0.043, 0.042, 0.043, 0.042, 0.042, 0.043, 0.042, 0.043, 0.042, 0.043, 0.042, 0.042, 0.043, 0.042, 0.043, 0.042, 0.042, 0.043, 0.042, 0.042, 0.043, 0.042, 0.042, 0.043, 0.042, 0.042, 0.043, 0.042, 0.042, 0.043, 0.042, 0.042, 0.043, 0.042, 0.042, 0.042, 0.043, 0.042, 0.042, 0.042, 0.043, 0.042, 0.042, 0.042, 0.042, 0.043, 0.042, 0.042, 0.042, 0.042, 0.043, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.043, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.043, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.041, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.042, 0.041, 0.042, 0.042, 0.042, 0.042, 0.042, 0.041, 0.042, 0.042, 0.042, 0.042, 0.041, 0.042, 0.042, 0.042, 0.041, 0.042, 0.042, 0.041, 0.042, 0.042, 0.042, 0.041, 0.042, 0.042, 0.041, 0.042, 0.042, 0.041, 0.042, 0.041, 0.042, 0.042, 0.041, 0.042, 0.041, 0.042, 0.041, 0.042, 0.041, 0.042, 0.041, 0.042, 0.041, 0.042, 0.041, 0.042, 0.041, 0.042, 0.041, 0.042, 0.041, 0.042, 0.041, 0.041, 0.042, 0.041, 0.041, 0.042, 0.041, 0.041, 0.042, 0.041, 0.041, 0.042, 0.041, 0.041, 0.042, 0.041, 0.041, 0.041, 0.042, 0.041, 0.041, 0.041, 0.041, 0.042, 0.041, 0.041, 0.041, 0.041, 0.041, 0.042, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.041, 0.04, 0.041, 0.041, 0.041, 0.041, 0.041, 0.04, 0.041, 0.041, 0.041, 0.041, 0.04, 0.041, 0.041, 0.041, 0.04, 0.041, 0.041, 0.04, 0.041, 0.041, 0.04, 0.041, 0.041, 0.04, 0.041, 0.041, 0.04, 0.041, 0.04, 0.041, 0.04, 0.041, 0.041, 0.04, 0.041, 0.04, 0.041, 0.04, 0.041, 0.04, 0.041, 0.04, 0.04, 0.041, 0.04, 0.041, 0.04, 0.04, 0.041, 0.04, 0.041, 0.04, 0.04, 0.041, 0.04, 0.04, 0.041, 0.04, 0.04, 0.04, 0.041, 0.04, 0.04, 0.04, 0.041, 0.04, 0.04, 0.04, 0.04, 0.041, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.041, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.039, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.04, 0.039, 0.04, 0.04, 0.04, 0.04, 0.039, 0.04, 0.04, 0.04, 0.039, 0.04, 0.04, 0.04, 0.039, 0.04, 0.04, 0.039, 0.04, 0.04, 0.039, 0.04, 0.039, 0.04, 0.04, 0.039, 0.04, 0.039, 0.04, 0.039, 0.04, 0.04, 0.039, 0.04, 0.039, 0.04, 0.039, 0.039, 0.04, 0.039, 0.04, 0.039, 0.04, 0.039, 0.039, 0.04, 0.039, 0.04, 0.039, 0.039, 0.04, 0.039, 0.039, 0.039, 0.04, 0.039, 0.039, 0.04, 0.039, 0.039, 0.039, 0.039, 0.04, 0.039, 0.039, 0.039, 0.039, 0.04, 0.039, 0.039, 0.039, 0.039, 0.039, 0.039, 0.039, 0.039, 0.039, 0.04, 0.039, 0.039, 0.039, 0.039, 0.039, 0.039, 0.039, 0.039, 0.039, 0.038, 0.039, 0.039, 0.039, 0.039, 0.039, 0.039, 0.039, 0.039, 0.038, 0.039, 0.039, 0.039, 0.039, 0.039, 0.038, 0.039, 0.039, 0.039, 0.038, 0.039, 0.039, 0.039, 0.038, 0.039, 0.039, 0.038, 0.039, 0.039, 0.038, 0.039, 0.038, 0.039, 0.039, 0.038, 0.039, 0.038, 0.039, 0.038, 0.039, 0.038, 0.039, 0.038, 0.039, 0.038, 0.039, 0.038, 0.039, 0.038, 0.039, 0.038, 0.038, 0.039, 0.038, 0.038, 0.039, 0.038, 0.038, 0.039, 0.038, 0.038, 0.039, 0.038, 0.038, 0.038, 0.039, 0.038, 0.038, 0.038, 0.038, 0.038, 0.039, 0.038, 0.038, 0.038, 0.038, 0.038, 0.038, 0.038, 0.038, 0.039, 0.038, 0.038, 0.038, 0.038, 0.038, 0.038, 0.038, 0.038, 0.037, 0.038, 0.038, 0.038, 0.038, 0.038, 0.038, 0.038, 0.038, 0.037, 0.038, 0.038, 0.038, 0.038, 0.037, 0.038, 0.038, 0.038, 0.037, 0.038, 0.038, 0.037, 0.038, 0.038, 0.037, 0.038, 0.038, 0.037, 0.038, 0.037, 0.038, 0.038, 0.037, 0.038, 0.037, 0.038, 0.037, 0.038, 0.037, 0.038, 0.037, 0.037, 0.038, 0.037, 0.038, 0.037, 0.037, 0.038, 0.037, 0.037, 0.038, 0.037, 0.037, 0.038, 0.037, 0.037, 0.037, 0.037, 0.038, 0.037, 0.037, 0.037, 0.037, 0.037, 0.038, 0.037, 0.037, 0.037, 0.037, 0.037, 0.037, 0.037, 0.037, 0.037, 0.037, 0.037, 0.037, 0.037, 0.037, 0.037, 0.037, 0.036, 0.037, 0.037, 0.037, 0.037, 0.037, 0.036, 0.037, 0.037, 0.037, 0.036, 0.037, 0.037, 0.037, 0.036, 0.037, 0.037, 0.036, 0.037, 0.036, 0.037, 0.037, 0.036, 0.037, 0.036, 0.037, 0.036, 0.037, 0.036, 0.037, 0.036, 0.037, 0.036, 0.036, 0.037, 0.036, 0.036, 0.037, 0.036, 0.036, 0.037, 0.036, 0.036, 0.036, 0.037, 0.036, 0.036, 0.036, 0.036, 0.037, 0.036, 0.036, 0.036, 0.036, 0.036, 0.036, 0.036, 0.036, 0.036, 0.036, 0.036, 0.036, 0.036, 0.036, 0.036, 0.036, 0.036, 0.036, 0.036, 0.035, 0.036, 0.036, 0.036, 0.036, 0.035, 0.036, 0.036, 0.036, 0.035, 0.036, 0.036, 0.035, 0.036, 0.036, 0.035, 0.036, 0.035, 0.036, 0.035, 0.036, 0.035, 0.036, 0.035, 0.036, 0.035, 0.036, 0.035, 0.036, 0.035, 0.035, 0.036, 0.035, 0.035, 0.036, 0.035, 0.035, 0.035, 0.036, 0.035, 0.035, 0.035, 0.036, 0.035, 0.035, 0.035, 0.035, 0.035, 0.035, 0.035, 0.035, 0.035, 0.035, 0.035, 0.035, 0.035, 0.035, 0.035, 0.035, 0.035, 0.035, 0.035, 0.035, 0.035, 0.034, 0.035, 0.035, 0.035, 0.035, 0.034, 0.035, 0.035, 0.034, 0.035, 0.035, 0.035, 0.034, 0.035, 0.034, 0.035, 0.035, 0.034, 0.035, 0.034, 0.035, 0.034, 0.035, 0.034, 0.035, 0.034, 0.035, 0.034, 0.034, 0.035, 0.034, 0.035, 0.034, 0.034, 0.035, 0.034, 0.034, 0.034, 0.035, 0.034, 0.034, 0.034, 0.035, 0.034, 0.034, 0.034, 0.034, 0.034, 0.034, 0.035, 0.034, 0.034, 0.034, 0.034, 0.034, 0.034, 0.034, 0.034, 0.034, 0.034, 0.034, 0.034, 0.034, 0.034, 0.033, 0.034]
b_list = [6188, 6188, 6188, 2960.5, 6187, 2961, 2961, 2961, 2961, 1887, 1887, 1887, 1887, 1887, 1351.25, 1351.25, 1351.25, 1351.25, 1030.6, 1351, 1030.8, 817.5, 1030.6, 817.6666667, 1030.4, 666, 817.6666667, 817.6666667, 666.2857143, 666.2857143, 666.2857143, 553.125, 666.1428571, 553.25, 553.25, 465.6666667, 553.125, 465.7777778, 465.7777778, 465.7777778, 396.2, 465.6666667, 396.3, 396.3, 396.3, 339.8181818, 396.2, 339.9090909, 339.9090909, 293.1666667, 339.8181818, 293.25, 293.25, 293.25, 293.25, 293.25, 254.2307692, 254.2307692, 254.2307692, 254.2307692, 221.0714286, 221.0714286, 254.0769231, 221.1428571, 192.6666667, 221.0714286, 192.7333333, 221, 192.8, 168.1875, 192.7333333, 192.7333333, 168.3125, 168.3125, 168.3125, 168.3125, 147, 147, 168.1875, 147.0588235, 147.0588235, 128.3888889, 147, 128.4444444, 128.4444444, 128.4444444, 128.4444444, 128.4444444, 112.1052632, 112.1052632, 112.1052632, 112.1052632, 112.1052632, 112.1052632, 97.7, 112.0526316, 97.75, 97.75, 84.9047619, 97.7, 84.95238095, 97.65, 85, 85, 85, 73.63636364, 84.95238095, 73.68181818, 73.68181818, 73.68181818, 73.68181818, 73.68181818, 63.60869565, 73.63636364, 63.65217391, 63.65217391, 63.65217391, 63.65217391, 54.66666667, 63.60869565, 54.70833333, 54.70833333, 54.70833333, 54.70833333, 54.70833333, 46.72, 54.66666667, 46.76, 46.76, 46.76, 46.76, 39.61538462, 46.72, 39.65384615, 46.68, 39.69230769, 39.69230769, 33.2962963, 39.65384615, 39.65384615, 33.37037037, 33.37037037, 33.37037037, 33.37037037, 33.37037037, 33.37037037, 27.75, 33.33333333, 27.78571429, 27.78571429, 27.78571429, 27.78571429, 27.78571429, 22.79310345, 27.75, 22.82758621, 22.82758621, 27.67857143, 22.86206897, 18.4, 22.82758621, 22.82758621, 18.46666667, 18.46666667, 22.75862069, 18.5, 18.5, 14.58064516, 18.46666667, 18.46666667, 14.64516129, 14.64516129, 18.4, 14.67741935, 14.67741935, 11.25, 14.64516129, 14.64516129, 11.3125, 14.61290323, 11.34375, 11.34375, 11.34375, 11.34375, 11.34375, 8.424242424, 11.3125, 11.3125, 8.484848485, 8.484848485, 8.484848485, 8.484848485, 8.484848485, 8.484848485, 8.484848485, 6.029411765, 8.454545455, 6.058823529, 6.058823529, 8.393939394, 6.088235294, 6.088235294, 6.088235294, 4, 6.058823529, 6.058823529, 4.057142857, 4.057142857, 6, 4.085714286, 4.085714286, 4.085714286, 4.085714286, 4.085714286, 2.416666667, 4.057142857, 2.444444444, 4.028571429, 2.472222222, 2.472222222, 3.971428571, 2.5, 2.5, 1.162162162, 2.472222222, 2.472222222, 2.472222222, 1.243243243, 2.444444444, 1.27027027, 1.27027027, 1.27027027, 2.361111111, 1.297297297, 1.297297297, 0.342105263, 1.27027027, 1.27027027, 1.27027027, 0.421052632, 1.243243243, 0.447368421, 0.447368421, 1.189189189, 0.473684211, 0.473684211, 0.473684211, 0.473684211, 0.473684211, 0.473684211, -0.051282051, 0.447368421, 0.447368421, 0, 0.421052632, 0.025641026, 0.025641026, 0.368421053, 0.051282051, 0.051282051, 0.051282051, 0.051282051, 0.051282051, 0.051282051, 0.051282051, -0.075, 0.025641026, 0.025641026, -0.025, 0, 0, 0.025, 0.025, -0.051282051, 0.05, 0.05, -0.102564103, 0.075, 0.075, 0.075, 0.075, 0.075, 0.075, 0.075, 0.075, 0.075, 0.075, 0.487804878, 0.05, 0.05, 0.05, 0.56097561, 0.025, 0.585365854, 0, 0.609756098, -0.025, 0.634146341, 0.634146341, -0.075, 0.658536585, 0.658536585, 0.658536585, -0.15, 0.682926829, 0.682926829, 0.682926829, 0.682926829, 0.682926829, 0.682926829, 0.682926829, 0.682926829, 0.682926829, 0.682926829, 0.682926829, 0.682926829, 0.682926829, 1.785714286, 0.658536585, 0.658536585, 0.658536585, 1.857142857, 0.634146341, 0.634146341, 1.904761905, 0.609756098, 0.609756098, 1.952380952, 0.585365854, 0.585365854, 2, 0.56097561, 2.023809524, 0.536585366, 2.047619048, 0.512195122, 2.071428571, 0.487804878, 2.095238095, 0.463414634, 2.119047619, 0.43902439, 2.142857143, 0.414634146, 2.166666667, 0.390243902, 2.19047619, 2.19047619, 0.341463415, 2.214285714, 0.317073171, 2.238095238, 0.292682927, 2.261904762, 0.268292683, 2.285714286, 0.243902439, 2.30952381, 0.219512195, 2.333333333, 0.195121951, 2.357142857, 0.170731707, 2.380952381, 0.146341463, 2.404761905, 0.12195122, 0.12195122, 2.452380952, 0.097560976, 2.476190476, 0.073170732, 0.073170732, 2.523809524, 0.048780488, 0.048780488, 0.048780488, 2.595238095, 0.024390244, 0.024390244, 0.024390244, 0.024390244, 2.69047619, 1.02318e-12, -1.44951e-12, 1.03739e-12, -1.47793e-12, 1.06581e-12, -1.49214e-12, 1.08002e-12, 1.08002e-12, -1.54898e-12, 1.10845e-12, -1.56319e-12, -3.1, 0.024390244, 0.024390244, 0.024390244, 0.024390244, -3.2, 0.048780488, 0.048780488, -3.25, 0.073170732, 0.073170732, -3.3, 0.097560976, -3.325, 0.12195122, 0.12195122, -3.375, -3.375, 0.170731707, -3.4, 0.195121951, -3.425, -3.425, 0.243902439, -3.45, -3.45, 0.292682927, -3.475, -3.475, -3.475, -3.475, 0.390243902, -3.5, -3.5, -3.5, -3.5, -3.5, -3.5, -3.5, 0.56097561, -3.525, -3.525, -3.525, -3.525, -3.525, -3.525, -3.525, -3.525, -8.025641026, -3.5, -3.5, -3.5, -3.5, -3.5, -3.5, -3.5, -3.5, -3.5, -3.5, -3.5, -3.5, -8.333333333, -3.475, -3.475, -3.475, -3.475, -3.475, -3.475, -3.475, -3.475, -3.475, -3.475, -3.475, -3.475, -3.475, -8.666666667, -3.45, -3.45, -3.45, -3.45, -3.45, -3.45, -3.45, -3.45, 1.707317073, -3.475, -3.475, -3.475, -3.475, -3.475, -3.475, -3.475, -3.475, 1.902439024, -3.5, -3.5, -3.5, -3.5, 2, -3.525, -3.525, -3.525, 2.073170732, -3.55, -3.55, 2.12195122, -3.575, -3.575, 2.170731707, -3.6, 2.195121951, -3.625, 2.219512195, -3.65, 2.243902439, -3.675, 2.268292683, -3.7, 2.292682927, -3.725, 2.317073171, 2.317073171, -3.775, 2.341463415, 2.341463415, -3.825, 2.365853659, 2.365853659, 2.365853659, -3.9, 2.390243902, 2.390243902, 2.390243902, 2.390243902, -4, 2.414634146, 2.414634146, 2.414634146, 2.414634146, 2.414634146, 2.414634146, 2.414634146, 2.414634146, 2.414634146, 2.414634146, 2.414634146, 2.414634146, 2.414634146, 2.414634146, 2.414634146, 2.414634146, 2.414634146, 8.928571429, 2.390243902, 2.390243902, 2.390243902, 2.390243902, 9.023809524, 2.365853659, 2.365853659, 2.365853659, 9.095238095, 2.341463415, 2.341463415, 2.341463415, 9.166666667, 2.317073171, 2.317073171, 9.214285714, 2.292682927, 2.292682927, 9.261904762, 2.268292683, 9.285714286, 2.243902439, 9.30952381, 2.219512195, 2.219512195, 9.357142857, 2.195121951, 9.380952381, 2.170731707, 9.404761905, 2.146341463, 9.428571429, 9.428571429, 2.097560976, 9.452380952, 2.073170732, 9.476190476, 2.048780488, 9.5, 9.5, 2, 9.523809524, 9.523809524, 1.951219512, 9.547619048, 9.547619048, 1.902439024, 9.571428571, 9.571428571, 1.853658537, 9.595238095, 9.595238095, 9.595238095, 1.780487805, 9.619047619, 9.619047619, 9.619047619, 1.707317073, 9.642857143, 9.642857143, 9.642857143, 9.642857143, 1.609756098, 9.666666667, 9.666666667, 9.666666667, 9.666666667, 9.666666667, 9.666666667, 1.463414634, 9.69047619, 9.69047619, 9.69047619, 9.69047619, 9.69047619, 9.69047619, 9.69047619, 9.69047619, 9.69047619, 9.69047619, 9.69047619, 9.69047619, 9.69047619, 9.69047619, 9.69047619, 9.69047619, 9.69047619, 9.69047619, 9.69047619, 9.69047619, 9.69047619, 9.69047619, 9.69047619, 9.69047619, 9.69047619, 9.69047619, 9.69047619, 9.69047619, 9.69047619, 9.69047619, 9.69047619, 9.69047619, 18.27906977, 9.666666667, 9.666666667, 9.666666667, 9.666666667, 9.666666667, 9.666666667, 18.41860465, 9.642857143, 9.642857143, 9.642857143, 9.642857143, 9.642857143, 18.53488372, 9.619047619, 9.619047619, 9.619047619, 9.619047619, 18.62790698, 9.595238095, 9.595238095, 9.595238095, 18.69767442, 9.571428571, 9.571428571, 9.571428571, 18.76744186, 9.547619048, 9.547619048, 18.81395349, 9.523809524, 9.523809524, 9.523809524, 18.88372093, 9.5, 9.5, 18.93023256, 9.476190476, 9.476190476, 18.97674419, 9.452380952, 9.452380952, 19.02325581, 9.428571429, 19.04651163, 9.404761905, 9.404761905, 19.09302326, 9.380952381, 9.380952381, 19.13953488, 9.357142857, 19.1627907, 9.333333333, 19.18604651, 9.30952381, 9.30952381, 19.23255814, 9.285714286, 19.25581395, 9.261904762, 19.27906977, 9.238095238, 9.238095238, 19.3255814, 9.214285714, 19.34883721, 9.19047619, 19.37209302, 9.166666667, 19.39534884, 9.142857143, 19.41860465, 9.119047619, 19.44186047, 9.095238095, 19.46511628, 9.071428571, 19.48837209, 9.047619048, 19.51162791, 9.023809524, 19.53488372, 9, 19.55813953, 19.55813953, 8.952380952, 19.58139535, 8.928571429, 19.60465116, 8.904761905, 19.62790698, 8.880952381, 19.65116279, 19.65116279, 8.833333333, 19.6744186, 8.80952381, 19.69767442, 19.69767442, 8.761904762, 19.72093023, 8.738095238, 19.74418605, 8.714285714, 19.76744186, 19.76744186, 8.666666667, 19.79069767, 8.642857143, 19.81395349, 19.81395349, 8.595238095, 19.8372093, 19.8372093, 8.547619048, 19.86046512, 8.523809524, 19.88372093, 19.88372093, 8.476190476, 19.90697674, 19.90697674, 8.428571429, 19.93023256, 8.404761905, 19.95348837, 19.95348837, 8.357142857, 19.97674419, 19.97674419, 8.30952381, 20, 20, 8.261904762, 20.02325581, 8.238095238, 20.04651163, 20.04651163, 8.19047619, 20.06976744, 20.06976744, 8.142857143, 20.09302326, 20.09302326, 8.095238095, 20.11627907, 20.11627907, 8.047619048, 20.13953488, 20.13953488, 8, 20.1627907, 20.1627907, 7.952380952, 20.18604651, 7.928571429, 20.20930233, 20.20930233, 7.880952381, 20.23255814, 20.23255814, 7.833333333, 20.25581395, 20.25581395, 7.785714286, 20.27906977, 20.27906977, 7.738095238, 20.30232558, 7.714285714, 20.3255814, 20.3255814, 7.666666667, 20.34883721, 20.34883721, 7.619047619, 20.37209302, 7.595238095, 20.39534884, 20.39534884, 7.547619048, 20.41860465, 20.41860465, 7.5, 20.44186047, 7.476190476, 20.46511628, 20.46511628, 7.428571429, 20.48837209, 7.404761905, 20.51162791, 20.51162791, 7.357142857, 20.53488372, 7.333333333, 20.55813953, 20.55813953, 7.285714286, 20.58139535, 7.261904762, 20.60465116, 7.238095238, 20.62790698, 7.214285714, 20.65116279, 20.65116279, 7.166666667, 20.6744186, 7.142857143, 20.69767442, 7.119047619, 20.72093023, 7.095238095,
          20.74418605, 7.071428571, 20.76744186, 7.047619048, 20.79069767, 7.023809524, 20.81395349, 7, 20.8372093, 6.976190476, 20.86046512, 6.952380952, 20.88372093, 6.928571429, 20.90697674, 6.904761905, 20.93023256, 6.880952381, 20.95348837, 6.857142857, 20.97674419, 6.833333333, 6.833333333, 21.02325581, 6.809523809, 21.04651163, 6.785714286, 21.06976744, 6.761904762, 6.761904762, 21.11627907, 6.738095238, 21.13953488, 6.714285714, 6.714285714, 21.18604651, 6.69047619, 6.69047619, 21.23255814, 6.666666667, 6.666666667, 21.27906977, 6.642857143, 6.642857143, 21.3255814, 6.619047619, 6.619047619, 21.37209302, 6.595238095, 6.595238095, 21.41860465, 6.571428571, 6.571428571, 6.571428571, 21.48837209, 6.547619048, 6.547619048, 6.547619048, 21.55813953, 6.523809524, 6.523809524, 6.523809524, 6.523809524, 21.65116279, 6.5, 6.5, 6.5, 6.5, 21.74418605, 6.476190476, 6.476190476, 6.476190476, 6.476190476, 6.476190476, 6.476190476, 21.88372093, 6.452380952, 6.452380952, 6.452380952, 6.452380952, 6.452380952, 6.452380952, 6.452380952, 6.452380952, 6.452380952, 6.452380952, 22.11627907, 6.428571429, 6.428571429, 6.428571429, 6.428571429, 6.428571429, 6.428571429, 6.428571429, 6.428571429, 6.428571429, 6.428571429, 6.428571429, -10.29268293, 6.452380952, 6.452380952, 6.452380952, 6.452380952, 6.452380952, 6.452380952, 6.452380952, 6.452380952, 6.452380952, 6.452380952, 6.452380952, -10.56097561, 6.476190476, 6.476190476, 6.476190476, 6.476190476, 6.476190476, -10.68292683, 6.5, 6.5, 6.5, 6.5, -10.7804878, 6.523809524, 6.523809524, 6.523809524, -10.85365854, 6.547619048, 6.547619048, -10.90243902, 6.571428571, 6.571428571, 6.571428571, -10.97560976, 6.595238095, 6.595238095, -11.02439024, 6.619047619, 6.619047619, -11.07317073, 6.642857143, -11.09756098, 6.666666667, 6.666666667, -11.14634146, 6.690476191, -11.17073171, 6.714285714, -11.19512195, 6.738095238, -11.2195122, 6.761904762, -11.24390244, 6.785714286, -11.26829268, 6.80952381, -11.29268293, 6.833333333, -11.31707317, 6.857142857, -11.34146341, 6.880952381, -11.36585366, 6.904761905, -11.3902439, -11.3902439, 6.952380952, -11.41463415, -11.41463415, 7, -11.43902439, -11.43902439, 7.047619048, -11.46341463, -11.46341463, 7.095238095, -11.48780488, -11.48780488, 7.142857143, -11.51219512, -11.51219512, -11.51219512, 7.214285714, -11.53658537, -11.53658537, -11.53658537, -11.53658537, 7.309523809, -11.56097561, -11.56097561, -11.56097561, -11.56097561, -11.56097561, 7.428571428, -11.58536585, -11.58536585, -11.58536585, -11.58536585, -11.58536585, -11.58536585, -11.58536585, -11.58536585, -11.58536585, -11.58536585, -11.58536585, -11.58536585, -11.58536585, -11.58536585, -11.58536585, -11.58536585, -11.58536585, -11.58536585, -11.58536585, -11.58536585, -11.58536585, -11.58536585, -11.58536585, -11.58536585, -11.58536585, -11.58536585, -32.2, -11.56097561, -11.56097561, -11.56097561, -11.56097561, -11.56097561, -32.325, -11.53658537, -11.53658537, -11.53658537, -11.53658537, -32.425, -11.51219512, -11.51219512, -11.51219512, -32.5, -11.48780488, -11.48780488, -32.55, -11.46341463, -11.46341463, -32.6, -11.43902439, -11.43902439, -32.65, -11.41463415, -11.41463415, -32.7, -11.3902439, -32.725, -11.36585366, -32.75, -11.34146341, -11.34146341, -32.8, -11.31707317, -32.825, -11.29268293, -32.85, -11.26829268, -32.875, -11.24390244, -32.9, -32.9, -11.19512195, -32.925, -11.17073171, -32.95, -32.95, -11.12195122, -32.975, -11.09756098, -33, -33, -11.04878049, -33.025, -33.025, -11, -33.05, -33.05, -33.05, -10.92682927, -33.075, -33.075, -33.075, -10.85365854, -33.1, -33.1, -33.1, -33.1, -10.75609756, -33.125, -33.125, -33.125, -33.125, -33.125, -33.125, -33.125, -10.58536585, -33.15, -33.15, -33.15, -33.15, -33.15, -33.15, -33.15, -33.15, -33.15, -33.15, -33.15, -33.15, -33.15, -33.15, -33.15, -33.15, -33.15, -57.30769231, -33.125, -33.125, -33.125, -33.125, -33.125, -33.125, -33.125, -57.48717949, -33.1, -33.1, -33.1, -33.1, -57.58974359, -33.075, -33.075, -33.075, -57.66666667, -33.05, -33.05, -33.05, -57.74358974, -33.025, -33.025, -57.79487179, -33, -33, -57.84615385, -32.975, -57.87179487, -32.95, -32.95, -57.92307692, -32.925, -57.94871795, -32.9, -57.97435897, -32.875, -32.875, -58.02564103, -32.85, -58.05128205, -32.825, -58.07692308, -58.07692308, -32.775, -58.1025641, -32.75, -58.12820513, -32.725, -58.15384615, -58.15384615, -32.675, -58.17948718, -32.65, -58.20512821, -58.20512821, -32.6, -58.23076923, -58.23076923, -58.23076923, -32.525, -58.25641026, -58.25641026, -32.475, -58.28205128, -58.28205128, -58.28205128, -58.28205128, -32.375, -58.30769231, -58.30769231, -58.30769231, -58.30769231, -32.275, -58.33333333, -58.33333333, -58.33333333, -58.33333333, -58.33333333, -58.33333333, -58.33333333, -58.33333333, -58.33333333, -32.05, -58.35897436, -58.35897436, -58.35897436, -58.35897436, -58.35897436, -58.35897436, -58.35897436, -58.35897436, -58.35897436, -86.28947368, -58.33333333, -58.33333333, -58.33333333, -58.33333333, -58.33333333, -58.33333333, -58.33333333, -58.33333333, -86.5, -58.30769231, -58.30769231, -58.30769231, -58.30769231, -58.30769231, -86.63157895, -58.28205128, -58.28205128, -58.28205128, -86.71052632, -58.25641026, -58.25641026, -58.25641026, -86.78947368, -58.23076923, -58.23076923, -86.84210526, -58.20512821, -58.20512821, -86.89473684, -58.17948718, -86.92105263, -58.15384615, -58.15384615, -86.97368421, -58.12820513, -87, -58.1025641, -87.02631579, -58.07692308, -87.05263158, -58.05128205, -87.07894737, -58.02564103, -87.10526316, -58, -87.13157895, -57.97435897, -87.15789474, -57.94871795, -87.18421053, -87.18421053, -57.8974359, -87.21052632, -87.21052632, -57.84615385, -87.23684211, -87.23684211, -57.7948718, -87.26315789, -87.26315789, -57.74358974, -87.28947368, -87.28947368, -87.28947368, -57.66666667, -87.31578947, -87.31578947, -87.31578947, -87.31578947, -87.31578947, -57.53846154, -87.34210526, -87.34210526, -87.34210526, -87.34210526, -87.34210526, -87.34210526, -87.34210526, -87.34210526, -57.33333333, -87.36842105, -87.36842105, -87.36842105, -87.36842105, -87.36842105, -87.36842105, -87.36842105, -87.36842105, -119.2432432, -87.34210526, -87.34210526, -87.34210526, -87.34210526, -87.34210526, -87.34210526, -87.34210526, -87.34210526, -119.4594595, -87.31578947, -87.31578947, -87.31578947, -87.31578947, -119.5675676, -87.28947368, -87.28947368, -87.28947368, -119.6486486, -87.26315789, -87.26315789, -119.7027027, -87.23684211, -87.23684211, -119.7567568, -87.21052632, -87.21052632, -119.8108108, -87.18421053, -119.8378378, -87.15789474, -87.15789474, -119.8918919, -87.13157895, -119.9189189, -87.10526316, -119.9459459, -87.07894737, -119.972973, -87.05263158, -120, -120, -87, -120.027027, -86.97368421, -120.0540541, -120.0540541, -86.92105263, -120.0810811, -120.0810811, -86.86842105, -120.1081081, -120.1081081, -86.81578947, -120.1351351, -120.1351351, -120.1351351, -120.1351351, -86.71052632, -120.1621622, -120.1621622, -120.1621622, -120.1621622, -120.1621622, -86.57894737, -120.1891892, -120.1891892, -120.1891892, -120.1891892, -120.1891892, -120.1891892, -120.1891892, -120.1891892, -120.1891892, -120.1891892, -120.1891892, -120.1891892, -120.1891892, -120.1891892, -120.1891892, -120.1891892, -156.1111111, -120.1621622, -120.1621622, -120.1621622, -120.1621622, -120.1621622, -156.25, -120.1351351, -120.1351351, -120.1351351, -156.3333333, -120.1081081, -120.1081081, -120.1081081, -156.4166667, -120.0810811, -120.0810811, -156.4722222, -120.0540541, -156.5, -120.027027, -120.027027, -156.5555556, -120, -156.5833333, -119.972973, -156.6111111, -119.9459459, -156.6388889, -119.9189189, -156.6666667, -119.8918919, -156.6944444, -156.6944444, -119.8378378, -156.7222222, -156.7222222, -119.7837838, -156.75, -156.75, -119.7297297, -156.7777778, -156.7777778, -156.7777778, -119.6486486, -156.8055556, -156.8055556, -156.8055556, -156.8055556, -119.5405405, -156.8333333, -156.8333333, -156.8333333, -156.8333333, -156.8333333, -156.8333333, -156.8333333, -156.8333333, -156.8333333, -156.8333333, -156.8333333, -156.8333333, -156.8333333, -156.8333333, -156.8333333, -156.8333333, -156.8333333, -156.8333333, -156.8333333, -196.8, -156.8055556, -156.8055556, -156.8055556, -156.8055556, -196.9142857, -156.7777778, -156.7777778, -156.7777778, -197, -156.75, -156.75, -197.0571429, -156.7222222, -156.7222222, -197.1142857, -156.6944444, -197.1428571, -156.6666667, -197.1714286, -156.6388889, -197.2, -156.6111111, -197.2285714, -156.5833333, -197.2571429, -156.5555556, -197.2857143, -156.5277778, -197.3142857, -197.3142857, -156.4722222, -197.3428571, -197.3428571, -156.4166667, -197.3714286, -197.3714286, -197.3714286, -156.3333333, -197.4, -197.4, -197.4, -156.25, -197.4285714, -197.4285714, -197.4285714, -197.4285714, -197.4285714, -197.4285714, -197.4285714, -197.4285714, -197.4285714, -197.4285714, -197.4285714, -197.4285714, -197.4285714, -197.4285714, -197.4285714, -197.4285714, -197.4285714, -197.4285714, -197.4285714, -197.4285714, -197.4285714, -241.6470588, -197.4, -197.4, -197.4, -197.4, -241.7647059, -197.3714286, -197.3714286, -241.8235294, -197.3428571, -197.3428571, -197.3428571, -241.9117647, -197.3142857, -241.9411765, -197.2857143, -197.2857143, -242, -197.2571429, -242.0294118, -197.2285714, -242.0588235, -197.2, -242.0882353, -197.1714286, -242.1176471, -197.1428571, -242.1470588, -242.1470588, -197.0857143, -242.1764706, -197.0571429, -242.2058824, -242.2058824, -197, -242.2352941, -242.2352941, -242.2352941, -196.9142857, -242.2647059, -242.2647059, -242.2647059, -196.8285714, -242.2941176, -242.2941176, -242.2941176, -242.2941176, -242.2941176, -242.2941176, -196.6571429, -242.3235294, -242.3235294, -242.3235294, -242.3235294, -242.3235294, -242.3235294, -242.3235294, -242.3235294, -242.3235294, -242.3235294, -242.3235294, -242.3235294, -242.3235294, -242.3235294, -291.1818182, -242.2941176]


Flag = {
    "BaoYa_Flag": False,
    "SHIYAN_Flag": False,
    "temp_before_fire": None,
    "temp_before_fire1": None
}
